---
title: Firefox 27 for developers
slug: Mozilla/Firefox/Releases/27
tags:
  - Firefox
---
<div>{{FirefoxSidebar}}</div><p>Firefox 27 was released on February 4, 2014. This article lists key changes that are useful not only for web developers, but also Firefox and Gecko developers as well as add-on developers.</p>

<h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<ul>
 <li>Breakpoints can now be set on DOM events.</li>
 <li>JavaScript in the debugger panel can be unminified, using the { } button.</li>
 <li>The inspector now has an "edit-element-html" feature, without needing an add-on.</li>
 <li>Background-URLs and colors have preview in inspector. Even hovering over canvas elements will give a pop-up with an image preview.</li>
 <li>Reflow logging has been added.</li>
 <li>Styles of SVG elements are now inspectable ({{Bug(921191)}}).</li>
 <li>Failure to find the image when clicking URL link in CSS inspector has been fixed ({{Bug(921686)}}).</li>
 <li>The {{HTTPHeader("SourceMap", "X-SourceMap")}} header is now supported ({{bug(765993)}}).</li>
</ul>

<p>More details in <a href="https://hacks.mozilla.org/2013/11/firefox-developer-tools-episode-27-edit-as-html-codemirror-more/">this post</a>.</p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The <code>-moz-grab</code> and <code>-moz-grabbing</code> keywords on the CSS {{cssxref("cursor")}} property have been unprefixed to <code>grab</code> and <code>grabbing</code> ({{bug("880672")}}).</li>
 <li>Support for the <code>-moz-hsla()</code> and <code>-moz-rgba()</code> functional notations has been dropped. Only the unprefixed versions, <code>hsla()</code> and <code>rgba()</code> are supported from now on ({{bug("893319")}}).</li>
 <li>The "<code>true</code>" value for {{cssxref("text-align")}} has been added ({{bug(929991)}}).</li>
 <li>Experimental support of <code>position:sticky</code> is now active by default on non-release builds ({{bug("902992")}}). For releases builds, the <code>layout.css.sticky.enabled</code> preference still needs to be set to <code>true.</code></li>
 <li>The {{cssxref("all")}} shorthand property has been added ({{bug(842329)}}).</li>
 <li>The {{cssxref("unset")}} global value has been added; it allows to reset any CSS property ({{bug(921731)}}).</li>
 <li>Curly brackets are no longer allowed in HTML <code>style</code> attributes: doing <code>&lt;div style="{ display: none }"&gt;</code> was working in quirks mode, but won't anymore {{bug(915053)}}.</li>
 <li>The {{cssxref("overflow")}} property now works on {{HTMLElement("fieldset")}} ({{bug(261037)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>The <code>color</code> value of the {{HTMLElement("input")}} {{htmlattrxref("type", "input")}} attribute has been implemented on desktop platforms. It was already available on mobile ones.</li>
 <li>The <code>allow-popups</code> directive is now supported with the {{htmlattrxref("sandbox", "iframe")}} attribute of the {{HTMLElement("iframe")}} element ({{bug(766282)}}).</li>
 <li>Blending of HTML elements using the {{cssxref("mix-blend-mode")}} property has been implemented. The <code>layout.css.mix-blend-mode.enabled</code> preference must be set to <code>true</code> ({{bug(902525)}}).</li>
 <li>The {{htmlattrxref("typemustmatch", "object")}} attribute on the {{HTMLElement("object")}} element is now supported ({{bug(827160)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<p><a href="/en-US/docs/Web/JavaScript/ECMAScript_6_support_in_Mozilla">EcmaScript 2015</a> implementation continues!</p>

<ul>
 <li>The <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Spread_operator">spread operator</a> is now supported in Function calls ({{bug("762363")}}).</li>
 <li>The mathematical function {{jsxref("Global_Objects/Math/hypot", "Math.hypot()")}} has been implemented ({{bug("896264")}}).</li>
 <li>The {{jsxref("Operators/yield*", "yield*")}} expression is now implemented ({{bug(666396)}}).</li>
 <li>The <code>MapIterator</code>, <code>SetIterator</code> and <code>ArrayIterator</code> objects now match the specification ({{bug("881226")}}).</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">for..of</a> loops now expect the ES2015 standard <a href="/en-US/docs/Web/JavaScript/Guide/The_Iterator_protocol">iterator protocol</a> moving away from SpiderMonkey old iterator protocol using <code>StopIteration</code>.</li>
 <li>{{jsxref("String.match")}} and {{jsxref("String.replace")}} now reset {{jsxref("RegExp.lastIndex")}} ({{bug(501739)}}).</li>
</ul>

<h3 id="InterfacesAPIsDOM">Interfaces/APIs/DOM</h3>

<ul>
 <li>Support for the two <code>setRange()</code> methods on the {{domxref("HTMLInputElement")}} interface has been added ({{bug(850364)}}).</li>
 <li>Support for the two <code>setRange()</code> methods on the {{domxref("HTMLTextAreaElement")}} interface has been added ({{bug(918940)}}).</li>
 <li>The methods <code>getAllKeys()</code> and <code>openKeyCursor()</code> have been added to {{domxref("IDBObjectStore")}} ({{bug(920633)}} and {{bug(920800)}}).</li>
 <li>The {{domxref("HTMLFormControlsCollection")}} interface has been implemented ({{bug(913920)}}).</li>
 <li>The {{domxref("CanvasRenderingContext2D")}} interface now supports the two methods {{domxref("CanvasRenderingContext2D.getLineDash()", "getLineDash()")}} and {{domxref("CanvasRenderingContext2D.setLineDash()", "setLineDash()")}} and the {{domxref("CanvasRenderingContext2D.lineDashOffset", "lineDashOffset")}} property  ({{bug(768067)}}).</li>
 <li>The <code>typeMustMatch</code> attribute has been implemented on the {{domxref("HTMLObjectElement")}} interface ({{bug(827160)}}).</li>
 <li>The <code>copyFromChannel()</code> and <code>copyToChannel()</code> methods have been added to {{domxref("AudioBuffer")}} ({{bug(915524)}}).</li>
 <li><code>Event.isTrusted()</code> is now unforgeable ({{bug(637248)}}).</li>
 <li>The WebRTC API's {{domxref("RTCIceCandidate")}} object now includes a {{domxref("RTCIceCandidate.toJSON", "toJSON()")}} method to help with signaling and debugging ({{bug(928304)}}).</li>
 <li>The {{domxref("Navigator.vibrate()")}} method has been adapted to match the final specification: It now returns <code>false</code> when the list is too long or has too large entries, instead of throwing ({{bug(884935)}}).</li>
 <li>As part of the ongoing effort to standardize global objects, the non-standard stylesheet change event interfaces, including <code>StyleRuleChangeEvent</code>, <code>StyleSheetApplicableStateChangeEvent</code> and <code>StyleSheetChangeEvent</code>, are no longer available from Web content. The <code>CSSGroupRuleRuleList</code> interface, the implementation detail of {{domxref("CSSRuleList")}}, has also been removed ({{Bug("872934")}} and {{bug(916871)}}).</li>
 <li><code>atob</code> now ignores whitespaces ({{bug(711180)}}).</li>
 <li><a href="/en-US/docs/Web/WebGL">WebGL</a>: <code>MOZ_</code> prefixed extension strings are deprecated. Support for them will be removed in the future. Use unprefixed extension string only. To get draft extensions, set the <code>webgl.enable-draft-extensions</code> preferences ({{bug(924176)}}).</li>
</ul>

<h3 id="MathML">MathML</h3>

<p><em>No change.</em></p>

<h3 id="SVG">SVG</h3>

<ul>
 <li>Blending of SVG elements using the {{cssxref("mix-blend-mode")}} property has been implemented. The <code>layout.css.mix-blend-mode.enabled</code> preference must be set to <code>true</code> ({{bug(902525)}}).</li>
</ul>

<h2 id="Changes_for_addon_and_Mozilla_developers">Changes for addon and Mozilla developers</h2>

<ul>
 <li>The <code>downloads-indicator</code> button has gone away. You should now use the <code>downloads-button</code> element. If you need to check that it has loaded its overlay, check for the <code>indicator</code> attribute on that button.</li>
 <li>The <code>chrome://browser/skin/downloads/indicator.css</code> stylesheet is no longer referenced in Firefox.</li>
</ul>

<h2 id="Security">Security</h2>

<ul>
 <li>TLS 1.2 has been implemented for improved security ({{Bug(861266)}}).</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/27/">Site Compatibility for Firefox 27</a></li>
 <li><a href="https://bugzilla.mozilla.org/buglist.cgi?resolution=FIXED&amp;component=Marionette&amp;product=Testing&amp;target_milestone=mozilla27">List of changes</a> in <a href="/en-US/docs/Mozilla/QA/Marionette">Marionette</a> for Firefox 27.</li>
</ul>

<h3 id="Older_versions">Older versions</h3>

<p>{{Firefox_for_developers('26')}}</p>
